package PFSaver;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.StringTokenizer;

import WinPacketFiltering.PacketFiltering;
import WinPacketFiltering.PacketFilteringException;

public class PFSaver_CUI
{
	private PFSaver saver = new PFSaver();
	private static final String fFolder = "FILTERS"; // tB^t@CۑpfBNg
	private static final String hFolder = "HANDLES"; // nht@Cۑp
	private static final String lFolder = "RECORD";  // Iꎞt@Cۑp
	private BufferedReader systemIn = new BufferedReader(new InputStreamReader(System.in));
	
	// RXgN^itB^Anh̕ۑpfBNgj
	public PFSaver_CUI() throws Exception
	{
		File fFldr = new File(fFolder);
		if(!fFldr.exists())
		{
			fFldr.mkdir();
		}
		else
		{
			if(fFldr.isFile())
				throw new Exception("Delete \""+fFolder+
						"\" File Before Starting This Application");
		}
		
		File hFldr = new File(hFolder);
		if(!hFldr.exists())
		{
			hFldr.mkdir();
		}
		else
		{
			if(hFldr.isFile())
				throw new Exception("Delete \""+hFolder+
						"\" File Before Starting This Application");
		}
		
		File lFldr = new File(lFolder);
		if(!lFldr.exists())
		{
			lFldr.mkdir();
		}
		else
		{
			if(lFldr.isFile())
				throw new Exception("Delete \""+lFolder+
						"\" File Before Starting This Application");
		}
		
		// OIt@Cǂݍ
		saver.restoreList(lFolder);
	} // PFSaver_CUI END
	
	// Cj[\
	private void showMainMenu()
		throws PacketFilteringException, IOException, Exception
	{
		while(true)
		{
			boolean isFinished = false;
			
			try
			{
				System.out.println("1. Start Filtering");
				System.out.println("2. Stop Filtering");
				System.out.println("3. Operate Interface");
				System.out.println("4. Operate Filter");
				System.out.println("9. Finish");
				
				System.out.print("> ");
				String input = systemIn.readLine();
				System.out.println();
				
				try
				{
					int inNum = Integer.parseInt(input);
					switch(inNum)
					{
					case 1: startFiltering();		break;
					case 2: stopFiltering();		break;
					case 3: showHandleMenu();		break;	
					case 4: showFilterMenu();		break;
					case 9: isFinished=true;		break;
					default: System.out.println("No Such Command!\n");
					}
				}
				catch(NumberFormatException nfe)
				{
					System.out.println("Incorrect Input!\n");
				}
			}
			catch(Exception e)
			{
				System.out.println("Unexpected Error Occurred!");
				e.printStackTrace();
				System.exit(1);
			}
			
			if(isFinished) break;
		}
		
		finisher();
	} // showMainMenu END
	
	// tB^OJn
	private void startFiltering() throws IOException, PacketFilteringException
	{
		if(saver.isWorking())
		{
			System.out.println("Filtering has Worked Already!\n");
			return;
		}
		
		if(saver.getHandleNum()==0)
		{
			System.out.println("No Handle Has Been Made Yet!\n");
			return;
		}
		
		try
		{
			InetAddress adrs = InetAddressInputter("Bound IPAddress");
			
			System.out.println();
			showAllHandle();
			System.out.println();
			System.out.println("Inbound Interface Handle Number");
			System.out.print("> ");
			int inbound = Integer.parseInt(systemIn.readLine())-1;
			System.out.println("Outbound Interface Handle Number");
			System.out.print("> ");
			int outbound = Integer.parseInt(systemIn.readLine())-1;
			System.out.println();
			
			saver.startFiltering(adrs, inbound, outbound);
		}
		catch(NumberFormatException nfe)
		{
			System.out.println("Incorrect Input!\n");
		}
	} // startFiltering END
	
	// tB^O~
	private void stopFiltering() throws PacketFilteringException
	{
		if(!saver.isWorking())
		{
			System.out.println("Filtering isn't Working Now!\n");
			return;
		}
		saver.stopFiltering();
	} // stopFiltering END
	
	// I
	private void finisher() throws PacketFilteringException, IOException, Exception
	{
		if(saver.isWorking())
		{
			stopFiltering();
		}
		
		saver.recordList(lFolder);
	} // finisher END
	
	
	
	// C^tF[Xnh֘Ãj[\
	private void showHandleMenu()
		throws IOException, ClassNotFoundException
	{
		while(true)
		{
			boolean isFinished = false;

			System.out.println("1. Show All Interface Handle");
			System.out.println("2. Make New Interface Handle");
			System.out.println("3. Delete Interface Handle");
			System.out.println("4. Edit Interface Handle");
			System.out.println("5. Load Interface Handle File");
			System.out.println("6. Save Interface Handle File");
			System.out.println("7. Delete Interface Handle File");
			System.out.println("9. Return");
			
			try
			{
				System.out.print("> ");
				String input = systemIn.readLine();
				System.out.println();
				
				int inNum = Integer.parseInt(input);
				switch(inNum)
				{
				case 1: showAllHandle();
						systemIn.readLine();	break;
				case 2: makeNewHandle();		break;
				case 3: deleteHandle();			break;	
				case 4: showEditHandleMenu();	break;
				case 5: loadHandle();			break;
				case 6: saveHandle();			break;
				case 7: deleteHandleFile();		break;
				case 9: isFinished=true;		break;
				default: System.out.println("No Such Command!\n");
				}
			}
			catch(NumberFormatException nfe)
			{
				System.out.println("Incorrect Input!\n");
			}
			
			if(isFinished) break;
		}
	} // showHandleMenu END
	
	// SẴC^tF[Xnh\
	private void showAllHandle()
	{
		if(saver.getHandleNum()==0)
		{
			System.out.println("No Interface Handle Has Been Made Yet!\n");
			return;
		}
		
		for(int i=0;i<saver.getHandleNum();i++)
		{
			System.out.println((i+1)+" : "+saver.getHandleString(i));
		}
	} // showAllHandle END
	
	// VC^tF[Xnh쐬
	private void makeNewHandle() throws IOException
	{
		System.out.println("1. Black List Interface Handle");
		System.out.println("2. White List Interface Handle");
		
		try
		{
			System.out.print("> ");
			String input = systemIn.readLine();
			
			int inNum = Integer.parseInt(input);
			System.out.println();
			
			switch(inNum)
			{
			case 1: saver.addBlackListHandle(); break;
			case 2: saver.addWhiteListHandle(); break;
			default: System.out.println("No Such Command!\n");
			}
		}
		catch(NumberFormatException nfe)
		{
			System.out.println("Incorrect Input!\n");
		}
	} // makeNewHandle END
	
	// C^tF[Xnh폜
	private void deleteHandle() throws IOException
	{
		if(saver.getHandleNum()==0)
		{
			System.out.println("No Interface Handle Has Been Made Yet!\n");
			return;
		}
		
		showAllHandle();
		
		try
		{
			System.out.println("Interface Handle Number");
			System.out.print("> ");
			String input = systemIn.readLine();
			System.out.println();
			
			if(input.equalsIgnoreCase("all"))
			{
				saver.clearHandle();
			}
			else
			{
				int index = Integer.parseInt(input)-1;
				try
				{
					saver.removeHandle(index);
				}
				catch(IndexOutOfBoundsException ioobe)
				{
					System.out.println("Incorrect Input!\n");
				}
			}
		}
		catch(NumberFormatException nfe)
		{
			System.out.println("Incorrect Input!\n");
		}
	} // deleteHandle END
	
	// C^tF[Xnht@C[h
	private void loadHandle() throws IOException, ClassNotFoundException
	{
		// C^tF[Xnht@Cꗗ̎擾
		String[] hlist = PFSaver.searchHandle(hFolder);
		
		if(hlist.length==0)
		{
			System.out.println("Found No Interface Handle File\n");
			return;
		}
		
		for(int i=0;i<hlist.length;i++)
		{
			System.out.println((i+1)+" : "+hlist[i]);
		}
		
		try
		{
			System.out.println("Interface Handle Number");
			System.out.print("> ");
			int input = Integer.parseInt(systemIn.readLine())-1;
			System.out.println();
			
			saver.readInterfaceHandle(hFolder+"\\"+hlist[input]);
		}
		catch(NumberFormatException nfe)
		{
			System.out.println("Incorrect Input!\n");
		}
		catch(IndexOutOfBoundsException ioobe)
		{
			System.out.println("Incorrect Input!\n");
		}
		catch(IOException ioe)
		{
			throw ioe;
		}
		catch(ClassNotFoundException cnfe)
		{
			throw cnfe;
		}
		catch(Exception e)
		{
			System.out.println("Can't This Handle!\n");
		}
	} // loadHandle END
	
	// C^tF[Xnhۑ
	private void saveHandle() throws IOException
	{
		if(saver.getHandleNum()==0)
		{
			System.out.println("No Handle Has Been Made Yet!\n");
			return;
		}
		
		showAllHandle();
		
		try
		{
			System.out.println("Interface Handle Number");
			System.out.print("> ");
			int index = Integer.parseInt(systemIn.readLine())-1;
			
			System.out.println("Interface Handle File Name");
			System.out.print("> ");
			String filename = systemIn.readLine();
			
			// ㏑
			if(PFSaver.existHandle(hFolder+"\\"+filename))
			{
				System.out.println("Overwrite? Y/N");
				while(true)
				{
					System.out.print("> ");
					String input = systemIn.readLine();
					if(input.equalsIgnoreCase("Y"))
					{
						try
						{
							saver.writeInterfaceHandle(hFolder+"\\"+filename, index);
						}
						catch(IndexOutOfBoundsException ioobe)
						{
							System.out.println("Incorrect Input!\n");
							continue;
						}
						
						break;
					}
					else if(input.equalsIgnoreCase("N"))
					{
						break;
					}
					else
					{
						System.out.println("Incorrect Input!\n");
					}
				}
				System.out.println();
			}
			else
			{
				try
				{
					System.out.println();
					saver.writeInterfaceHandle(hFolder+"\\"+filename, index);
				}
				catch(IndexOutOfBoundsException ioobe)
				{
					System.out.println("Incorrect Input!\n");
				}
			}
		}
		catch(NumberFormatException nfe)
		{
			System.out.println("Incorrect Input!\n");
		}
	} // saveHandle END
	
	// C^tF[Xnht@C폜
	private void deleteHandleFile() throws IOException
	{
		// C^tF[Xnht@Cꗗ̎擾
		String[] hlist = PFSaver.searchHandle(hFolder);
		
		if(hlist.length==0)
		{
			System.out.println("Found No Interface Handle File\n");
			return;
		}
		
		for(int i=0;i<hlist.length;i++)
		{
			System.out.println((i+1)+" : "+hlist[i]);
		}
		
		try
		{
			System.out.println("Interface Handle Number");
			System.out.print("> ");
			int input = Integer.parseInt(systemIn.readLine())-1;
			System.out.println();
			
			try
			{
				PFSaver.deleteHandle(hFolder+"\\"+hlist[input]);
			}
			catch(IndexOutOfBoundsException ioobe)
			{
				System.out.println("Incorrect Input!\n");
			}
			catch(Exception e)
			{
				System.out.println("Can't Delete This File!\n");
			}
		}
		catch(NumberFormatException nfe)
		{
			System.out.println("Incorrect Input!\n");
		}
	} // deleteHandleFile END

	
	
	// C^tF[XnhҏWj[\
	private void showEditHandleMenu() throws IOException
	{
		if(saver.getHandleNum()==0)
		{
			System.out.println("No Handle Has Been Made Yet!\n");
			return;
		}
		
		while(true)
		{
			boolean isFinished = false;

			System.out.println("1. Show Filters in Interface Handle");
			System.out.println("2. Add Filter to Interface Handle");
			System.out.println("3. Remove Filter from Interface Handle");
			System.out.println("9. Return");
			
			System.out.print("> ");
			String input = systemIn.readLine();
			System.out.println();
			
			try
			{
				int inNum = Integer.parseInt(input);
				switch(inNum)
				{
				case 1:	showFiltersInHandle();
						systemIn.readLine();		break;
				case 2: addFilterToHandle();		break;
				case 3: removeFilterFromHandle();	break;	
				case 9: isFinished=true;			break;
				default: System.out.println("No Such Command!\n");
				}
			}
			catch(NumberFormatException nfe)
			{
				System.out.println("Incorrect Input!\n");
			}
			
			if(isFinished) break;
		}
	} // showEditHandleMenu END
	
	// C^tF[Xnh̑SẴtB^\
	private void showFiltersInHandle() throws IOException
	{
		showAllHandle();
		
		try
		{
			System.out.println("Interface Handle Number");
			System.out.print("> ");
			int input = Integer.parseInt(systemIn.readLine())-1;
			System.out.println();
			
			String[] list = saver.toStringFiltersInHandle(input);
			
			if(list.length==0)
			{
				System.out.println("No Filter is Added in!");
				return;
			}
			
			for(int i=0;i<list.length;i++)
			{
				System.out.println(list[i]);
			}
		}
		catch(NumberFormatException nfe)
		{
			System.out.println("Incorrect Input!\n");
		}
		catch(IndexOutOfBoundsException ioobe)
		{
			System.out.println("Incorrect Input!\n");
		}
	} // showFiltersInHandle END
	
	// tB^C^tF[Xnhɉ
	private void addFilterToHandle() throws IOException
	{
		try
		{
			showAllHandle();
			System.out.println("Interface Handle Number");
			System.out.print("> ");
			int hnum = Integer.parseInt(systemIn.readLine())-1;
			System.out.println();
			
			if(hnum > saver.getHandleNum()-1 || hnum < 0)
				throw new IndexOutOfBoundsException("Index: "+Integer.toString(hnum));
				
			if(saver.getFilterNum()==0)
			{
				System.out.println("No Filter Has Been Made Yet!\n");
				return;
			}
			
			showAllFilter();
			System.out.println("Filter Number");
			System.out.print("> ");
			int fnum = Integer.parseInt(systemIn.readLine())-1;
			System.out.println();
			
			saver.setFilterToHandle(hnum,fnum);
		}
		catch(NumberFormatException nfe)
		{
			System.out.println("Incorrect Input!\n");
		}
		catch(IndexOutOfBoundsException ioobe)
		{
			System.out.println("Incorrect Input!\n");
		}
	} // addFilterToHandle END
	
	// C^tF[XnhtB^菜
	private void removeFilterFromHandle() throws IOException
	{
		showAllHandle();
		
		try
		{
			System.out.println("Interface Handle Number");
			System.out.print("> ");
			int hIndex = Integer.parseInt(systemIn.readLine())-1;
			System.out.println();
			
			String[] list = saver.toStringFiltersInHandle(hIndex);
			
			if(list.length==0)
			{
				System.out.println("No Filter is Added in!\n");
				return;
			}
			
			for(int i=0;i<list.length;i++)
			{
				System.out.println((i+1)+" : "+list[i]);
			}
			System.out.println("Filter Number");
			System.out.print("> ");
			int fIndex = Integer.parseInt(systemIn.readLine())-1;
			System.out.println();
			
			saver.removeFilterFromHandle(hIndex, fIndex);
		}
		catch(NumberFormatException nfe)
		{
			System.out.println("Incorrect Input!\n");
		}
		catch(IndexOutOfBoundsException ioobe)
		{
			System.out.println("Incorrect Input!\n");
		}
	} // removeFilterFromHandle END
	
	
	
	// tB^֘Ãj[\
	private void showFilterMenu()
		throws IOException, PacketFilteringException, ClassNotFoundException
	{
		while(true)
		{
			boolean isFinished = false;
			
			System.out.println("1. Show All Filter");
			System.out.println("2. Make new Filter");
			System.out.println("3. Delete Filter");
			System.out.println("4. Edit Filter");
			System.out.println("5. Load Filter File");
			System.out.println("6. Save Filter File");
			System.out.println("7. Delete Filter File");
			System.out.println("9. Return");
			
			try
			{
				System.out.print("> ");
				String input = systemIn.readLine();
				System.out.println();
				
				int inNum = Integer.parseInt(input);
				switch(inNum)
				{
				case 1: showAllFilter();
						systemIn.readLine();	break;
				case 2: makeNewFilter();		break;
				case 3: deleteFilter();			break;	
				case 4: editFilter();			break;
				case 5: loadFilter();			break;
				case 6: saveFilter();			break;
				case 7: deleteFilterFile();		break;
				case 9: isFinished=true;		break;
				default: System.out.println("No Such Command!\n");
				}
			}
			catch(NumberFormatException nfe)
			{
				System.out.println("Incorrect Input!\n");
			}
			
			if(isFinished) break;
		}
	} // showFilterMenu END
	
	// SẴtB^\
	private void showAllFilter()
	{
		if(saver.getFilterNum()==0)
		{
			System.out.println("No Filter Has Been Made Yet!\n");
			return;
		}
		
		for(int i=0;i<saver.getFilterNum();i++)
		{
			System.out.println((i+1)+" : "+saver.getFilterString(i));
		}
	} // showAllFilter END

	// tB^폜
	private void deleteFilter() throws IOException
	{
		if(saver.getFilterNum()==0)
		{
			System.out.println("No Filter Has Been Made Yet!\n");
			return;
		}
		
		showAllFilter();
		
		try
		{
			System.out.println("Filter Number");
			System.out.print("> ");
			String input = systemIn.readLine();
			System.out.println();
			
			if(input.equalsIgnoreCase("all"))
			{
				saver.clearFilter();
			}
			else
			{
				int index = Integer.parseInt(input)-1;
				saver.removeFilter(index);
			}
		}
		catch(NumberFormatException nfe)
		{
			System.out.println("Incorrect Input!\n");
		}
		catch(IndexOutOfBoundsException ioobe)
		{
			System.out.println("Incorrect Input!\n");
		}
	} // deleteFilter END
	
	// tB^t@C[h
	private void loadFilter() throws IOException, ClassNotFoundException
	{
		// tB^fBXNv^t@Cꗗ̎擾
		String[] list = PFSaver.searchFilter(fFolder);
		
		if(list.length==0)
		{
			System.out.println("Found No Filter File\n");
			return;
		}
		
		for(int i=0;i<list.length;i++)
		{
			System.out.println((i+1)+" : "+list[i]);
		}
		
		try
		{
			System.out.print("> ");
			int input = Integer.parseInt(systemIn.readLine())-1;
			System.out.println();
			
			try
			{
				saver.readFilterDescriptor(fFolder+"\\"+list[input]);
			}
			catch(IndexOutOfBoundsException ioobe)
			{
				System.out.println("Incorrect Input!\n");
			}
		}
		catch(NumberFormatException nfe)
		{
			System.out.println("Incorrect Input!\n");
		}
	} // loadFilter END
	
	// tB^t@Cɕۑ
	private void saveFilter() throws IOException
	{
		if(saver.getFilterNum()==0)
		{
			System.out.println("No Filter Has Been Made Yet!\n");
			return;
		}
		
		showAllFilter();
		
		try
		{
			System.out.println("Filter Number");
			System.out.print("> ");
			int index = Integer.parseInt(systemIn.readLine())-1;
			
			System.out.println("Filter File Name");
			String filename = systemIn.readLine();
			
			if(PFSaver.existFilter(fFolder+"\\"+filename))
			{
				System.out.println("Overwrite? Y/N");
				while(true)
				{
					System.out.print("> ");
					String input = systemIn.readLine();
					if(input.equalsIgnoreCase("Y"))
					{
						try
						{
							saver.writeFilterDescriptor(fFolder+"\\"+filename, index);
						}
						catch(IndexOutOfBoundsException ioobe)
						{
							System.out.println("Incorrect Input!");
							continue;
						}
						
						break;
					}
					else if(input.equalsIgnoreCase("N"))
					{
						break;
					}
					else
					{
						System.out.println("Incorrect Input!");
					}
				}
			}
			else
			{
				try
				{
					saver.writeFilterDescriptor(fFolder+"\\"+filename, index);
				}
				catch(IndexOutOfBoundsException ioobe)
				{
					System.out.println("Incorrect Input!");
				}
			}
			System.out.println();
		}
		catch(NumberFormatException nfe)
		{
			System.out.println("Incorrect Input!\n");
		}
	} // saveFilter END
	
	// tB^t@C폜
	private void deleteFilterFile() throws IOException
	{
		// tB^fBXNv^t@Cꗗ̎擾
		String[] list = PFSaver.searchFilter(fFolder);
		
		if(list.length==0)
		{
			System.out.println("Found No Filter File\n");
			return;
		}
		
		for(int i=0;i<list.length;i++)
		{
			System.out.println((i+1)+" : "+list[i]);
		}
		
		try
		{
			System.out.println("Filter File Number");
			System.out.print("> ");
			int index = Integer.parseInt(systemIn.readLine())-1;
			System.out.println();
			
			saver.deleteFilter(fFolder+"\\"+list[index]);
		}
		catch(NumberFormatException nfe)
		{
			System.out.println("Incorrect Input!\n");
		}
		catch(IndexOutOfBoundsException ioobe)
		{
			System.out.println("Incorrect Input!\n");
		}
	} // deleteFilterFile END

	
	
	// VtB^쐬
	private void makeNewFilter() throws IOException
	{
		System.out.println("1. IP Filter");
		System.out.println("2. ICMP Filter");
		System.out.println("3. TCP Filter");
		System.out.println("4. UDP Filter");
		System.out.println("9. Return");
		System.out.print("> ");
		
		try
		{
			String input = systemIn.readLine();
			System.out.println();
			
			int inNum = Integer.parseInt(input);
			switch(inNum)
			{
			case 1: makeNewIPFilter();		break;
			case 2: makeNewICMPFilter();	break;
			case 3: makeNewTCPFilter();		break;	
			case 4: makeNewUDPFilter();		break;
			default: System.out.println("No Such Command!\n");
			}
			System.out.println();
		}
		catch(NumberFormatException nfe)
		{
			System.out.println("Incorrect Input!\n");
		}
		catch(IllegalArgumentException iae)
		{
			System.out.println("Incorrect Input!\n");
		}
	} // makeNewFilter END
	
	// VIPtB^쐬
	private void makeNewIPFilter() throws IOException
	{
		InetAddress[] inetadrs = get4IPelements();
		
		saver.addIPfilter(inetadrs[0], inetadrs[1], inetadrs[2], inetadrs[3]);
	} // makeNewIPFilter END
	
	// VICMPtB^쐬
	private void makeNewICMPFilter() throws IOException
	{
		InetAddress[] inetadrs = get4IPelements();
		
		saver.addICMPfilter(inetadrs[0], inetadrs[1], inetadrs[2], inetadrs[3]);
	} // makeNewICMPFilter END
	
	// VTCPtB^쐬
	private void makeNewTCPFilter() throws IOException
	{
		InetAddress[] inetadrs = get4IPelements();
		
		int[] ports = get4port();
		
		saver.addTCPfilter(inetadrs[0], inetadrs[1], inetadrs[2], inetadrs[3],
				ports[0], ports[1], ports[2], ports[3]);
	} // makeNewTCPFilter END
	
	// VUDPtB^쐬
	private void makeNewUDPFilter() throws IOException
	{
		InetAddress[] inetadrs = get4IPelements();
		
		int[] ports = get4port();
		
		saver.addUDPfilter(inetadrs[0], inetadrs[1], inetadrs[2], inetadrs[3],
				ports[0], ports[1], ports[2], ports[3]);
	} // makeNewTCPFilter END
	
	
	
	// tB^ҏW
	private void editFilter() throws IOException
	{
		if(saver.getFilterNum()==0)
		{
			System.out.println("No Filter Has Been Made Yet!\n");
			return;
		}
		
		showAllFilter();
		
		try
		{
			System.out.println("Filter Number");
			System.out.print("> ");
			int input = Integer.parseInt(systemIn.readLine())-1;
			System.out.println();
			int protocol = saver.getFilterProtocol(input);
			switch(protocol)
			{
			case PacketFiltering.ANY_PROTOCOL:	editIPFilter(input);	break;
			case PacketFiltering.ICMP:			editICMPFilter(input);	break;
			case PacketFiltering.TCP: 			editTCPFilter(input);	break;
			case PacketFiltering.UDP:			editUDPFilter(input);	break;
			}
			System.out.println();
		}
		catch(NumberFormatException nfe)
		{
			System.out.println("Incorrect Input!\n");
		}
		catch(IndexOutOfBoundsException ioobe)
		{
			System.out.println("Incorrect Input!\n");
		}
		catch(IllegalArgumentException iae)
		{
			System.out.println("Incorrect Input!\n");
		}
	} // editFilter END
	
	// IPtB^ҏW
	private void editIPFilter(int index) throws IOException
	{
		InetAddress[] inetadrs = get4IPelementsE();
		
		try
		{
			saver.editIPFilter(index, inetadrs[0], inetadrs[1],
					inetadrs[2], inetadrs[3]);
		}
		catch(IndexOutOfBoundsException ioobe)
		{
			System.out.println("Incorrect Input!\n");
		}
	} // editIPFilter END
	
	// ICMPtB^ҏW
	private void editICMPFilter(int index) throws IOException
	{
		InetAddress[] inetadrs = get4IPelementsE();
		
		try
		{
			saver.editICMPFilter(index, inetadrs[0], inetadrs[1],
					inetadrs[2], inetadrs[3]);
		}
		catch(IndexOutOfBoundsException ioobe)
		{
			System.out.println("Incorrect Input!\n");
		}
	} // editICMPFilter END
	
	// TCPtB^ҏW
	private void editTCPFilter(int index) throws IOException
	{
		InetAddress[] inetadrs = get4IPelementsE();
		
		int[] ports = get4portE();
		
		try
		{
			saver.editTCPFilter(index, inetadrs[0], inetadrs[1], inetadrs[2],
					inetadrs[3], ports[0], ports[1], ports[2], ports[3]);
		}
		catch(IndexOutOfBoundsException ioobe)
		{
			System.out.println("Incorrect Input!\n");
		}
	} // editTCPFilter END
	
	// UDPtB^ҏW
	private void editUDPFilter(int index) throws IOException
	{
		InetAddress[] inetadrs = get4IPelementsE();
		
		int[] ports = get4portE();
		
		try
		{
			saver.editUDPFilter(index, inetadrs[0], inetadrs[1], inetadrs[2],
					inetadrs[3], ports[0], ports[1], ports[2], ports[3]);
		}
		catch(IndexOutOfBoundsException ioobe)
		{
			System.out.println("Incorrect Input!\n");
		}
	} // editUDPFilter END


	
	
	// MAM̃|[gԍƁiX`Yj߂
	private int[] get4port() throws IOException
	{
		int[] ports = new int[4];
		
		ports[0] = portInputter("Source Port");
		ports[2] = portInputter("Ceiling Source Port");
		ports[1] = portInputter("Destinatiopn Port");
		ports[3] = portInputter("Ceiling Destinatiopn Port");
		
		return ports;
	} // get4port END
	
	// MAM̃|[gԍƁiX`Yj߂
	private int[] get4portE() throws IOException
	{
		int[] ports = new int[4];
		
		ports[0] = portInputterE("Source Port");
		ports[2] = portInputterE("Ceiling Source Port");
		ports[1] = portInputterE("Destinatiopn Port");
		ports[3] = portInputterE("Ceiling Destinatiopn Port");
		
		return ports;
	} // get4portE END
	
	// InetAddress߂
	private InetAddress InetAddressInputterE(String s) throws IOException
	{
		InetAddress adrs;
		String input;
		
		while(true)
		{
			try
			{
				System.out.println(s);
				System.out.print("> ");
				input = systemIn.readLine();
				if(input.equalsIgnoreCase("localhost"))
				{
					adrs = InetAddress.getLocalHost();
				}
				else if(input.equalsIgnoreCase("nomask"))
				{
					adrs = PacketFiltering.NO_MASKv4;
				}
				else if(input.equalsIgnoreCase("nomaskv6"))
				{
					adrs = PacketFiltering.NO_MASKv6;
				}
				else if(input.equalsIgnoreCase("all"))
				{
					adrs = PacketFiltering.ALL_IPv4;
				}			
				else if(input.equalsIgnoreCase("allv6"))
				{
					adrs = PacketFiltering.ALL_IPv6;
				}
				else if(input.equalsIgnoreCase("noedit"))
				{
					adrs = null;
				}
				else
				{
					adrs = getByAddress(input);
				}
				break;
			}
			catch(UnknownHostException uhe)
			{
				System.out.println("Incorrect Input!\n");
			}
			catch(NumberFormatException nfe)
			{
				System.out.println("Incorrect Input!\n");
			}
		}
		
		return adrs;
	} // InetAddressInputterE END
	
	// InetAddress߂
	private InetAddress InetAddressInputter(String s) throws IOException
	{
		InetAddress adrs;
		String input;
		
		while(true)
		{
			try
			{
				System.out.println(s);
				System.out.print("> ");
				input = systemIn.readLine();
				if(input.equalsIgnoreCase("localhost"))
				{
					adrs = InetAddress.getLocalHost();
				}
				else if(input.equalsIgnoreCase("nomask"))
				{
					adrs = PacketFiltering.NO_MASKv4;
				}
				else if(input.equalsIgnoreCase("nomaskv6"))
				{
					adrs = PacketFiltering.NO_MASKv6;
				}
				else if(input.equalsIgnoreCase("all"))
				{
					adrs = PacketFiltering.ALL_IPv4;
				}			
				else if(input.equalsIgnoreCase("allv6"))
				{
					adrs = PacketFiltering.ALL_IPv6;
				}
				else
				{
					adrs = getByAddress(input);
				}
				break;
			}
			catch(UnknownHostException uhe)
			{
				System.out.println("Incorrect Input!\n");
			}
			catch(NumberFormatException nfe)
			{
				System.out.println("Incorrect Input!\n");
			}
		}
		
		return adrs;
	} // InetAddressInputter END
	
	// MAMIPAhXƃTulbg}XN͂
	private InetAddress[] get4IPelementsE() throws IOException
	{
		InetAddress[] inetadrs = new InetAddress[4];
		
		inetadrs[0] = InetAddressInputterE("Source IPAddress");
		inetadrs[1] = InetAddressInputterE("Source Subnet Mask");
		inetadrs[2] = InetAddressInputterE("Destinatiopn IPAddress");
		inetadrs[3] = InetAddressInputterE("Destinatiopn Subnet Mask");
		
		return inetadrs;
	} // get4IPelements END
	
	// MAMIPAhXƃTulbg}XN͂
	private InetAddress[] get4IPelements() throws IOException
	{
		InetAddress[] inetadrs = new InetAddress[4];
		
		inetadrs[0] = InetAddressInputter("Source IPAddress");
		inetadrs[1] = InetAddressInputter("Source Subnet Mask");
		inetadrs[2] = InetAddressInputter("Destinatiopn IPAddress");
		inetadrs[3] = InetAddressInputter("Destinatiopn Subnet Mask");
		
		return inetadrs;
	} // get4IPelements END
	
	// |[gԍ߂
	private int portInputter(String s) throws IOException
	{
		int port;
		String input;
		
		while(true)
		{
			try
			{
				System.out.println(s);
				System.out.print("> ");
				input = systemIn.readLine();
				if(input.equalsIgnoreCase("anyport"))
				{
					port = PacketFiltering.ANY_PORT;
				}
				else if(input.equalsIgnoreCase("noset"))
				{
					port = PacketFiltering.ONLY_1_PORT;
				}
				else
				{
					port = Integer.parseInt(input);
				}
				break;
			}
			catch(NumberFormatException nfe)
			{
				System.out.println("Incorrect Input!\n");
			}
		}
		
		return port;
	} // InetAddress END
	
	// |[gԍ߂
	private int portInputterE(String s) throws IOException
	{
		int port;
		String input;
		
		while(true)
		{
			try
			{
				System.out.println(s);
				System.out.print("> ");
				input = systemIn.readLine();
				if(input.equalsIgnoreCase("anyport"))
				{
					port = PacketFiltering.ANY_PORT;
				}
				else if(input.equalsIgnoreCase("noset"))
				{
					port = PacketFiltering.ONLY_1_PORT;
				}
				else if(input.equalsIgnoreCase("noedit"))
				{
					port = PacketFiltering.NO_SET;
				}
				else
				{
					port = Integer.parseInt(input);
				}
				break;
			}
			catch(NumberFormatException nfe)
			{
				System.out.println("Incorrect Input!\n");
			}
		}
		
		return port;
	} // InetAddress END
	
	// String`AhXInetAddress𓾂
	private static InetAddress getByAddress(String ipadrs)
		throws NumberFormatException, UnknownHostException
	{
		StringTokenizer tok = new StringTokenizer(ipadrs ,".");
		byte[] adrspart = new byte[tok.countTokens()];
		
		for(int i=0;tok.hasMoreTokens();i++)
		{
			String input = tok.nextToken();
			adrspart[i] = (byte)(Integer.parseInt(input));
		}
		
		return InetAddress.getByAddress(adrspart);
	} //InetAddress END
	
	
	
	public static void main(String[] args)
	{
		try
		{
			PFSaver_CUI app = new PFSaver_CUI();
			app.showMainMenu();
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
}
