package PFSaver;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.OutputStream;
import java.util.Enumeration;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;

public class ZipDecompresser
{
	public static Object decompress(ZipFile zipfile, ZipEntry entry)
		throws IOException, ClassNotFoundException
	{
		ObjectInputStream oin = null;
		Object obj = null;
		
		try
		{
			oin = new ObjectInputStream(zipfile.getInputStream(entry));
			obj = oin.readObject();
		}
		finally
		{
			if(oin!=null) oin.close();
		}

		return obj;
	}
	
	public static Object[] decompress(ZipFile zipfile)
		throws IOException, ClassNotFoundException
	{
		Object[] obj = new Object[zipfile.size()];
		Enumeration e = zipfile.entries();
		
		for(int i=0;e.hasMoreElements();i++)
		{
			ObjectInputStream in = null;
			try
			{
				in = new ObjectInputStream(zipfile.getInputStream(
						(ZipEntry)e.nextElement()));
				obj[i] = in.readObject();
			}
			finally
			{
				if(in!=null) in.close();
			}
		}
		
		return obj;
	}
}
