/*********************************************************************************
 * 
 * 		PacketFiltering NX
 * 
 * 	ݒ肳ꂽtB^ŃpPbgtB^Os
 * 
 * 
 * CoEhEAEgoEh̃C^tF[Xnh쐬
 * C^tF[Xnh̓ubNXgij
 * @zCgXgi֎~jݒ肷
 * C^tF[XnhɃtB^
 * ubNXgEnh̏ꍇAtB^ɍvpPbg͔j
 * zCgXgEnh̏ꍇAtB^ɍvpPbg͒ʉ߂
 * 
 *  
 *  
 * public \bh
 * Evoid BindInterfaceToIPAddress(InetAddress adrs, int adrsType,
 * 				INTERFACE_HANDLE inbound, INTERFACE_HANDLE outbound)
 *  	IPAhXɃC^tF[XnhoCh
 *  	itB^O̎sj
 *  
 * Evoid UnBindInterface()
 * 		oChĂC^tF[XnhAoCh
 * 		itB^O~j
 * 
 * EFILTER_DESCRIPTOR getICMPfilter()
 * 		ICMPtB^̐
 * 
 * EFILTER_DESCRIPTOR getIPfilter()
 * 		IPtB^̐
 * 
 * EFILTER_DESCRIPTOR getTCPfilter()
 * 		TCPtB^̐
 * 
 * EFILTER_DESCRIPTOR getUDPfilter()
 * 		UDPtB^̐
 * 
 *  
 * private \bh
 * EString PfCreateInterface(int dwName, boolean inAction, 
 * 			boolean outAction, boolean bUseLog, boolean bMustBeUnique)
 *  	tB^OC^tF[X̍쐬
 *  
 * EString PfAddFiltersToInterfaceIN(int addrType, byte[] SrcAddr, 
 * 			byte[] SrcMask, byte[] DstAddr, byte[] DstMask, int srcPort,
 * 			int dstPort, int ceilingSrcPort, int ceilingDstPort, int protocol)
 * 		tB^CoEhEC^tF[Xɉ
 * 
 * EString PfAddFiltersToInterfaceOUT(int addrType, byte[] SrcAddr, byte[] SrcMask, 
 *			byte[] DstAddr, byte[] DstMask, int srcPort, int dstPort, 
 *			int ceilingSrcPort, int ceilingDstPort, int protocol)
 *		tB^AEgoEhEC^tF[Xɉ
 *
 * EString PfBindInterfaceToIPAddress(int pfatType, byte[] IPAddress)
 *		tB^OC^tF[XIPAhXɃoCh
 *
 * EString PfUnBindInterface();
 *		tB^OC^tF[X̃AoCh
 *
 * EString PfDeleteInterface()
 *		tB^OC^tF[X̏
 *
 * EFILTER_DESCRIPTOR setBasicDescriptor(FILTER_DESCRIPTOR descriptor)
 * 		tB^̊{ݒs
 * 
 *********************************************************************************/

package WinPacketFiltering;

import java.net.InetAddress;
import java.net.UnknownHostException;
import WinPacketFiltering.FILTER_DESCRIPTOR;

public class PacketFiltering
{
	/*				Native Interface				*/
	
	private static final boolean DEBUG = false; // fobOtO
	
	private static final int iNULL = 0;
	private static final String NO_ERROR	= "NO_ERROR";
	private static final String NATIVE	= "NATIVE : ";
	
	// tB^O̎s
	public static void BindInterfaceToIPAddress(InetAddress adrs,
			int adrsType, INTERFACE_HANDLE inbound, INTERFACE_HANDLE outbound)
			throws PacketFilteringException
	{
		String result;
		
		// Netive: C^tF[X̐
		result = PfCreateInterface(
				iNULL, inbound.rule, outbound.rule, false, true);
		
		if(DEBUG) System.out.println("CreateInterface : "+result); // fobO
		
		failureProcessor(result);
		
		if(DEBUG) // fobO
		{
			System.out.println("filter num");
			System.out.println("in  : "+inbound.getSize());
			System.out.println("out : "+outbound.getSize());
		}
		
		// Native: CoEhtB^̒ǉ
		for(int i=0;i<inbound.getSize();i++)
		{
			FILTER_DESCRIPTOR filter = (FILTER_DESCRIPTOR)inbound.getFilter(i);
			
			result = PfAddFiltersToInterfaceIN(
					filter.AddrType,
					filter.SrcAddr.getAddress(),
					filter.SrcMask.getAddress(),
					filter.DstAddr.getAddress(),
					filter.DstMask.getAddress(),
					filter.SrcPort,
					filter.DstPort,
					filter.CeilingSrcPort,
					filter.CeilingDstPort,
					filter.Protocol
			);
			
			failureProcessor(result);
		}
		
		if(DEBUG) // fobO
		{
			System.out.println("AddFiltersToInterfaceIN : "+result);
		}
		
		// Native: AEgoEhtB^̒ǉ
		for(int i=0;i<outbound.getSize();i++)
		{
			FILTER_DESCRIPTOR filter = (FILTER_DESCRIPTOR)outbound.getFilter(i);
			
			result = PfAddFiltersToInterfaceOUT(
					filter.AddrType,
					filter.SrcAddr.getAddress(),
					filter.SrcMask.getAddress(),
					filter.DstAddr.getAddress(),
					filter.DstMask.getAddress(),
					filter.SrcPort,
					filter.DstPort,
					filter.CeilingSrcPort,
					filter.CeilingDstPort,
					filter.Protocol
			);
			
			failureProcessor(result);
		}
		
		if(DEBUG) System.out.println("AddFiltersToInterfaceOUT : "+result); // fobO
		
		// IPAhXɃoCh
		result = PfBindInterfaceToIPAddress(adrsType, adrs.getAddress());
		failureProcessor(result);
		
		if(DEBUG) System.out.println("BindInterfaceToIPAddress : "+result); // fobO
	}

	// tB^O̒~
	public static void UnBindInterface() throws PacketFilteringException
	{
		String result;
		
		result = PfUnBindInterface();
		failureProcessor(result);
		
		result = PfDeleteInterface();
		failureProcessor(result);
	}
	
	// lCeBu\bhs
	private static void failureProcessor(String result)
		throws PacketFilteringException
	{
		if(!result.equals(NO_ERROR))
		{
			PfDeleteInterface();
			throw new PacketFilteringException(NATIVE+result);
		}
	}
	
	
	// (Native) tB^OC^tF[X̍쐬
	private static native String PfCreateInterface(
			int			dwName,
			// PFFORWARD_ACTION
			boolean	inAction,
			// PFFORWARD_ACTION
			boolean	outAction,
			boolean	bUseLog,
			boolean	bMustBeUnique
	);
	
	// (Native) tB^CoEhEC^tF[Xɉ
	private static native String PfAddFiltersToInterfaceIN(	
			int		addrType,
			byte[]	SrcAddr,
			byte[]	SrcMask,
			byte[]	DstAddr,
			byte[]	DstMask,
			int		srcPort,
			int		dstPort,
			int		ceilingSrcPort,
			int		ceilingDstPort,
			int		protocol
	);
	
	// (Native) tB^AEgoEhEC^tF[Xɉ
	private static native String PfAddFiltersToInterfaceOUT(	
			int		addrType,
			byte[]	SrcAddr,
			byte[]	SrcMask,
			byte[]	DstAddr,
			byte[]	DstMask,
			int		srcPort,
			int		dstPort,
			int		ceilingSrcPort,
			int		ceilingDstPort,
			int		protocol
	);
	
	// (Native) tB^OC^tF[XIPAhXɃoCh
	private static native String PfBindInterfaceToIPAddress(
			int		pfatType,
			byte[]	IPAddress
	);
	
	// (Native) tB^OC^tF[X̃AoCh
	private static native String PfUnBindInterface();
	
	// (Native) tB^OC^tF[X̏
	private static native String PfDeleteInterface();
	
	static
	{
		System.loadLibrary("PacketFiltering"); // dll̃[h
	}
	
	/************************************************/
	
	/*				Java Methods					*/
	
	/** FIELD VALUE	**/
	// AddrType
	public static final int IPv4_FLAG		= 4;
	public static final int IPv6_FLAG		= 6;
	// SrcMask, DstMask
	private static final byte[] ALL_FFv4
					= {(byte)255, (byte)255, (byte)255, (byte)255};
	public static InetAddress NO_MASKv4;// = InetAddress.getByAddress(ALL_FFv4);
	private static final byte[] ALL_00v4
					= {(byte)0, (byte)0, (byte)0, (byte)0};
	public static InetAddress ALL_IPv4;// = InetAddress.getByAddress(ALL_00v4);
	private static final byte[] ALL_FFv6
		= {	(byte)255, (byte)255, (byte)255, (byte)255,
			(byte)255, (byte)255, (byte)255, (byte)255,
			(byte)255, (byte)255, (byte)255, (byte)255,
			(byte)255, (byte)255, (byte)255, (byte)255};
	public static InetAddress NO_MASKv6;// = InetAddress.getByAddress(ALL_FFv6);
	private static final byte[] ALL_00v6
		= {	(byte)0, (byte)0, (byte)0, (byte)0, (byte)0, (byte)0, (byte)0, (byte)0,
			(byte)0, (byte)0, (byte)0, (byte)0, (byte)0, (byte)0, (byte)0, (byte)0};
	public static InetAddress ALL_IPv6;// = InetAddress.getByAddress(ALL_00v6);
	// SrcPort, DstPort
	public static final int NO_SET	= -1;
	public static final int ANY_PORT	= 0;
	// CeilingSrcPort, CeilingDstPort
	public static final int ONLY_1_PORT	= -1;
	// Protocol
	public static final int ANY_PROTOCOL	= 1;
	public static final int ICMP			= 2;
	public static final int TCP			= 3;
	public static final int UDP			= 4;
	
	public static InetAddress	LOCAL_HOST;// = InetAddress.getLocalHost();
	/*					*/
	
	// tB^fBXNv^̊{ݒ
	private static FILTER_DESCRIPTOR setBasicDescriptor(FILTER_DESCRIPTOR descriptor)
	{
		descriptor.AddrType			= IPv4_FLAG;
		descriptor.SrcAddr			= null;
		descriptor.SrcMask			= NO_MASKv4;
		descriptor.DstAddr			= null;
		descriptor.DstMask			= NO_MASKv4;
		descriptor.SrcPort			= NO_SET;
		descriptor.DstPort			= NO_SET;
		descriptor.CeilingSrcPort	= ONLY_1_PORT;
		descriptor.CeilingDstPort	= ONLY_1_PORT;	
		descriptor.Protocol			= ANY_PROTOCOL;
		
		return descriptor;
	}
	
	// ICMPtB^VK쐬
	public static FILTER_DESCRIPTOR getICMPfilter()
	{
		FILTER_DESCRIPTOR descriptor = setBasicDescriptor(new FILTER_DESCRIPTOR());
		descriptor.Protocol = ICMP;
		
		return descriptor;
	}
	
	// IPtB^VK쐬
	public static FILTER_DESCRIPTOR getIPfilter()
	{
		FILTER_DESCRIPTOR descriptor = setBasicDescriptor(new FILTER_DESCRIPTOR());
		descriptor.SrcPort = ANY_PORT;
		descriptor.DstPort = ANY_PORT;
		descriptor.CeilingSrcPort = ANY_PORT;
		descriptor.CeilingDstPort = ANY_PORT;
		
		return descriptor;
	}
	
	// TCPtB^VK쐬
	public static FILTER_DESCRIPTOR getTCPfilter()
	{
		FILTER_DESCRIPTOR descriptor = setBasicDescriptor(new FILTER_DESCRIPTOR());
		descriptor.Protocol = TCP;
		
		return descriptor;
	}
	
	// UDPtB^VK쐬
	public static FILTER_DESCRIPTOR getUDPfilter()
	{
		FILTER_DESCRIPTOR descriptor = setBasicDescriptor(new FILTER_DESCRIPTOR());
		descriptor.Protocol = UDP;
		
		return descriptor;
	}
	
	static
	{			
		try
		{
			NO_MASKv4 = InetAddress.getByAddress(ALL_FFv4);
			ALL_IPv4 =  InetAddress.getByAddress(ALL_00v4);
			NO_MASKv6 = InetAddress.getByAddress(ALL_FFv6);
			ALL_IPv6 =  InetAddress.getByAddress(ALL_00v6);
			LOCAL_HOST = InetAddress.getLocalHost();
		}
		catch (UnknownHostException e)
		{
			e.printStackTrace();
		}
	}
	/*****************************************************************/
}
